// =============== Klassen-Definition: int_VEKTOR  ======================================
// intVEKTOR-Klasse fuer Vektor-Operationen vom Typ int
// (kann durch Template mit Klasse VEKTOR vereinigt werden)
// ======================================================================================
// Copyright: Univ.-Prof. Dr.-Ing. Udo F. Meissner, Erkrath/Darmstadt
// experimentelles Lehr- und Studienprogramm - kommerzielle Nutzung nicht gestattet
// Der Autor bernimmt keine Haftung fr Unvollstndigkeiten und Maengel der Algorithmen!
// Version:  5/1997
// Compiler: C++
// ================ Include-Files =======================================================
#include "pch.h"
#include "framework.h"
#include "MATRIXclass.h"
// ---------------------
// #include "intVektor.h"
// #include "intMatrix.h"
// ============================================================================
// public -> Oeffentliche Mitgliedsfunktionen
// ============================================================================
//
// Konstruktor -> intVEKTOR vek(ni)
// ================================
// ni: Dimension des 1D-Vektors, interne Speicherung -> vek(1,ni)
// --------------------------------------------------------------
intVEKTOR::intVEKTOR(int ni):intMATRIX(1,ni)
{
//***cerr<<"intVEKTOR::Konstruktor: neuen Vektor erzeugen"<<'\n';
};//---------------------------------------------------------------------------
//
// Konstruktor -> intVEKTOR vek(C_array,ni)
// ========================================
// C_array vorinitialisiert mittels Initialisierungsliste C_feld [] = { ... }
// ni: Dimension des 1D-Vektors, interne Speicherung -> vek(1,ni)
// --------------------------------------------------------------------------
intVEKTOR::intVEKTOR(int* C_array, int ni):intMATRIX(C_array,1,ni)
{
//*** std::cerr<<"intVEKTOR::Konstruktor: neuen Vektor erzeugen"<<'\n';
};//---------------------------------------------------------------------------
//
// Destruktor -> delete &vek
// =========================
intVEKTOR::~intVEKTOR(void)
{
//***cerr<<"intVEKTOR::Destruktor: Loeschen von intVEKTOR"<<'\n';
};//---------------------------------------------------------------------------
//
// Alle Vektor-Elemente belegen -> vek =zahl
// =========================================
// Hier nochmal, weil der Zuweisungsoperator  = nicht vererbt werden kann !!!
// --------------------------------------------------------------------------
intVEKTOR &intVEKTOR::operator = (int zahl)
{
this->zuweisen(zahl,0);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *this;
};//---------------------------------------------------------------------------
//
// Matrix zuweisen -> vek =mat (nur Matrizeninhalt kopieren)
// ===========================
// Hier nochmal, weil der Zuweisungsoperator  = nicht vererbt werden kann !!!
// --------------------------------------------------------------------------
intVEKTOR &intVEKTOR::operator  = (intMATRIX &mat)
{
this->zuweisen(mat,0);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
mat.temporaere_matrix_loeschen();
//
return *this;
};//---------------------------------------------------------------------------
//
// Multiplikation mit Skalar -> vek*zahl
// =====================================
intMATRIX &intVEKTOR::operator * (int zahl)
{
//***cerr<<"intVEKTOR:: vek*zahl"<<'\n';
//
return this->intMATRIX::operator *(zahl);
};//--------------------------------------------------------------------------
// WERT suchen
// ===========
// Argumente:
// knonr: Wert, nach dem gesucht wird
// n   : Laenge des Vektors
//     : -1 Laenge automatisch ermitteln 
// d   : Schrittweite, mit der der Vektor durchsucht wird
// Funktionsergebnis: relativer Anfangsindex (0,1,..), bei dem knonr gefunden
//                    -1 knonr wurde nicht gefunden
int intVEKTOR::wert_suchen(int knonr,int n,int d)
{
// Dimension von knotennummern ermitteln
int dim,ni,nj,nk,nl;
dim=n;
if(n < 0) dim=this->dimension_ermitteln(ni,nj,nk,nl);
//
int wert_intern=-1;
//
for(int i=0; i<dim/d; i+=d)
{
if(this->element(i) == knonr) {wert_intern=i; break;};
};
//
return wert_intern;
};
// ============================================================================
